/* cscreen.c
 * AUTHOR               : Samuel Behan <behan@frida.fri.utc.sk> (c) 2001
 * LICENSE              : GNU GPL v2 or later, NO WARANTY VOID provided
 * ABOUT                : see cscreen.h
 */

/*XXX: this implementation obsoletes itself ;-) - it so not good since it 
 * is not usable for real screen imaging. Need implement screen able 
 * to simulate real sceen management - like cursor seek, screen clean...
 */



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "cscreen.h"

#define CSC_SUCCESS	 0
#define CSC_ERROR	-1

cscreen_t *cscreen_open(unsigned int max_length)
{
    cscreen_t *csc;

    /* malloc main structure */
    csc = (cscreen_t *) malloc(sizeof(cscreen_t));
    if (csc == NULL)
	return NULL;
    /* malloc buffer */
    csc->buffer = (char *) malloc(sizeof(char) * (max_length + 1));

    if (csc->buffer == NULL)
    {
	free(csc);
	return NULL;
    }
    memset(csc->buffer, 0, max_length + 1);
    /* setup defaults */
    csc->size = max_length;
    csc->start = csc->load = 0;
    /* return pointer to created structure */
    return csc;
}

int cscreen_resize(cscreen_t * csc, unsigned int new_length)
{
    unsigned int size, start, load;
    char *buf = csc->buffer;

    /* just to be sure */
    if (csc->size == new_length)
	return CSC_SUCCESS;

    /* alloc new size */
    csc->buffer = (char *) malloc(sizeof(char) * (new_length + 1));

    if (csc->buffer == NULL)
    {
	csc->buffer = buf;
	return CSC_ERROR;
    }
    memset(csc->buffer, 0, new_length + 1);
    /* store old values */
    load = csc->load;
    start = csc->start;
    size = csc->size;
    /* copy data */
    if (csc->size > new_length)
    {
	if (csc->start + csc->load > csc->size)
	    csc->load = csc->size - csc->start;
	if (csc->load > new_length)
	    csc->load = new_length;
	memcpy(csc->buffer, buf + csc->start, csc->load);
	csc->start = 0;
	csc->size = new_length;
	if (start + load > csc->size)
	    cscreen_write(csc, buf + csc->load,
			  ((start + load) - csc->size));
    } else
    {
	unsigned int get = 0;

	if (csc->start + csc->load > csc->size)
	    csc->load = csc->size - csc->start;
	if (csc->load > new_length)
	    csc->load = new_length;
	memcpy(csc->buffer, buf + csc->start, csc->load);
	csc->start = 0;
	csc->size = new_length;
	while (start + csc->load < size)
	{
	    get = (size - (start + csc->load) > new_length) ? new_length :
		(size - (start + csc->load));
	    cscreen_write(csc, buf + start + csc->load, get);
	    csc->load += get;
	}
	if (csc->load < load)
	{
	    get = (start > new_length ? new_length : start);
	    cscreen_write(csc, buf, get);
	    csc->load = size;
	}
    }
    free(buf);
    return CSC_SUCCESS;
}

/*
 * FIXME: I'm still not sure about this routine. It look it works good,
 but some screens that should be OK are demaged like there were
 a small memmory write bug (maybe bad csc->start management) 
 */
int cscreen_write(cscreen_t * csc,
		  register const char *buffer, unsigned int length)
{
    if (length > csc->size)
    {				/* litle hack when incomming buffer > cache size */
	memcpy(csc->buffer, buffer + (length - csc->size), csc->size);
	csc->start = 0;
	csc->load = csc->size;
    } else if ((csc->load == csc->size) ||
	       (csc->start + csc->load + length >= csc->size))
    {				/* cache is full - start data remove */
	if (csc->start + length <= csc->size)
	{			/* copy data at end, move start */
	    memcpy(csc->buffer + csc->start, buffer, length);
	    csc->start += length;
	    if (csc->start == csc->size)
		csc->start = 0;
	} else
	{			/* data to long, fill remainning avaible space and begin from 0 + move start */
	    unsigned int pos = csc->start + csc->load;

	    if (pos >= csc->size)
		pos -= csc->size;
	    memcpy(csc->buffer + pos, buffer, (csc->size - (csc->start == 0 ? pos : csc->start)));
	    csc->start = length - (csc->size - (csc->start == 0 ? pos : csc->start));
	    memcpy(csc->buffer, buffer + (csc->size - csc->load),
		   csc->start);
	    csc->load = csc->size;
	}
    } else
    {				/* cache is just being loaded */
	memcpy(csc->buffer + csc->start + csc->load, buffer, length);
	csc->load += length;
    }
    return length;
}

/*
 * FIXME: Needs to be optimized !!!
 */
int cscreen_read(cscreen_t * csc, char *buffer, unsigned int length)
{
    unsigned int get = 0;
    int readed = 0;

    if (csc->load == 0)
	return CSC_ERROR;
    if (csc->start + csc->load > csc->size)
    {
	get = csc->size - csc->start;
	if (get > length)
	    get = length;
	memcpy(buffer, csc->buffer + csc->start, get);
	csc->load -= get;
	csc->start += get;
	if (csc->start >= csc->size)
	    csc->start -= csc->size;
	if (length - get > 0)
	    get += cscreen_read(csc, buffer + get, length - get);
	readed = get;
    } else
    {
	get = (length > csc->load ? csc->load : length);
	memcpy(buffer, csc->buffer + csc->start, get);
	csc->load -= get;
	csc->start += get;
	buffer[get] = '\0';
	readed += get;
    }
    return ((readed != 0) ? readed : CSC_ERROR);
}

int cscreen_print(cscreen_t * csc, register int f)
{
    if (csc->load >= csc->size)
    {
	if ((write(f, csc->buffer + csc->start, csc->size - csc->start) ==
	     -1)
	    || (write(f, csc->buffer, csc->start) == -1))
	    return CSC_ERROR;
    } else if (write(f, csc->buffer + csc->start, csc->load) == -1)
	return CSC_ERROR;
    return csc->load;
}

int cscreen_clear(cscreen_t * csc)
{
    memset(csc->buffer, 0, csc->size);
    csc->start = csc->load = 0;
    return CSC_SUCCESS;
}

int cscreen_close(cscreen_t * csc)
{
    free(csc->buffer);
    free(csc);
    return CSC_SUCCESS;
}
